/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef SCREEN_CONNECTOR_COMMON_HANDLE_H_
#define SCREEN_CONNECTOR_COMMON_HANDLE_H_

#include "screen_connector_common/export.h"

namespace screen_connector {

template <typename T>
class EXPORT Handle {
 public:
  explicit Handle(T raw, bool owner) : raw_(raw), owner_(owner) { }
  virtual ~Handle() { }

  T GetRaw() const {
    return raw_;
  }

  bool IsOwner() {
    return owner_;
  }

 private:
  T raw_;
  bool owner_;
};

}  // namespace screen_connector

#endif  // SCREEN_CONNECTOR_COMMON_HANDLE_H_
